﻿using System.Windows;
using System.Windows.Media;

namespace WheelScroller
{
	public static class FrameworkElementExtensions
	{
		/// <summary>
		/// Recursively searches the parents of the given element and checks whether the target is one of them.
		/// </summary>
		/// <returns>True if the target is one of the elements.</returns>
		public static bool IsAncestorOf(this FrameworkElement target, FrameworkElement element)
		{
			if (target == element)
			{
				return true;
			}
			FrameworkElement parent = VisualTreeHelper.GetParent(element) as FrameworkElement;
			while (parent != null)
			{
				if (parent == target)
				{
					return true;
				}
				parent = VisualTreeHelper.GetParent(parent) as FrameworkElement;
			}
			return false;
		}
	}
}
