﻿using System;
using System.Windows;
using System.Windows.Controls;

using Telerik.Windows;
using Telerik.Windows.Input;

namespace WheelScroller
{
	public partial class Page : UserControl
	{
		public Page()
		{
			InitializeComponent();

			Mouse.AddMouseWheelHandler(ScrollViewer1, 
				new EventHandler<MouseWheelEventArgs>(ScrollViewer_OnMouseWheelHandler));

			Mouse.AddMouseWheelHandler(ScrollViewer2, 
				new EventHandler<MouseWheelEventArgs>(ScrollViewer_OnMouseWheelHandler));

			EventManager.RegisterClassHandler(typeof(ScrollViewer), Mouse.MouseWheelEvent,
				new EventHandler<MouseWheelEventArgs>(ListBox1_OnMouseWheelHandler));
		}

		private bool Scroll(ScrollViewer scrollViewer, int delta, FrameworkElement element)
		{
			if (element != null && !element.IsAncestorOf(scrollViewer))
			{
				return false;
			}

			int scrollDelta = 40 * delta / 3;

			if (scrollViewer.ComputedVerticalScrollBarVisibility == Visibility.Visible)
			{
				scrollViewer.ScrollToVerticalOffset(
					Math.Min(scrollViewer.ScrollableHeight, scrollViewer.VerticalOffset - scrollDelta));
			}
			else if (scrollViewer.ComputedHorizontalScrollBarVisibility == Visibility.Visible)
			{
				scrollViewer.ScrollToHorizontalOffset(
					Math.Min(scrollViewer.ScrollableWidth, scrollViewer.HorizontalOffset - scrollDelta));
			}
			else
			{
				return false;
			}
			return true;
		}

		private void ScrollViewer_OnMouseWheelHandler(object sender, MouseWheelEventArgs args)
		{
			if (!args.Handled && Scroll(sender as ScrollViewer, args.Delta, null))
			{
				args.Handled = true;
			}
		}

		private void ListBox1_OnMouseWheelHandler(object sender, MouseWheelEventArgs args)
		{
			if (!args.Handled && Scroll(sender as ScrollViewer, args.Delta, ListBox1))
			{
				args.Handled = true;
			}
		}
	}
}